Unit ftfsc_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ftfsc(var ARE :Array of Real; var AIM :Array of Real;
                var N :Integer; L :Integer; var P :Real;
                var XRE :Array of Real; var XIM :Array of Real);

implementation

procedure ftfsc(var ARE :Array of Real; var AIM :Array of Real;
                var N :Integer; L :Integer; var P :Real;
                var XRE :Array of Real; var XIM :Array of Real);
var
I,J,K,M,JN,JJ,JK :Integer;
Q,T,C,S,CO,SI,RR,RI :Real;
label
_1,_2,_3;
begin
K := Trunc( N/L );
JK := 0;
for I:=1 to K do
 begin
_1:
  FTF1C(ARE,AIM,N,I,K,P);
 end;
Q := -2.0*P/(N);
for M:=1 to L do
 begin
  JJ := JK+1;
  JN := JJ+1;
  JK := JK+K;
  I := M;
  while ( I<=N ) do
   begin
    T := Q*(I-1);
    C := Cos(T);
    S := Sin(T);
    CO := C;
    SI := S;
    RR := ARE[JJ-1];
    RI := AIM[JJ-1];
    for J:=JN to JK do
     begin
      RR := RR+ARE[J-1]*CO-AIM[J-1]*SI;
      RI := RI+AIM[J-1]*CO+ARE[J-1]*SI;
      T := C*CO-S*SI;
      SI := C*SI+S*CO;
_2:
      CO := T;
     end;
    XRE[I-1] := RR;
_3:
    XIM[I-1] := RI;
    inc(I,L);
   end;
 end;
end;

end.
